<template>
  <div class="col">
    <b-form @submit.prevent="onSubmit" @reset="onReset">
      <div class="d-flex">
        <b-button
          @click="redirectToIndex"
          variant="secondary"
          class="mr-auto"
        >Back</b-button>

        <b-button
          v-if="isEditing"
          type="button"
          variant="danger"
          class="ml-2"
          :disabled="isBusy"
          @click="onDelete"
        >Delete</b-button>
      </div>

      <b-card
        v-for="panel in panels"
        :key="panel.key"
        :title="panel.label"
        :sub-title="panel.desc"
        class="my-3">

        <form-field
          v-for="field in panel.fields" :key="field.key"
          v-model="model[field.key]"
          :id="field.key"
          :type="field.type"
          :label="field.label"
          :desc="field.desc"
          :attrs="field.attrs"
          />

      </b-card>

      <div class="d-flex">
        <b-button
          type="reset"
          variant="outline-secondary"
          class="ml-auto"
          :disabled="isDisabled"
        >{{ resetBtn }}</b-button>

        <b-button
          type="submit"
          variant="primary"
          class="ml-2"
          :disabled="isDisabled"
        >{{ submitBtn }}</b-button>
      </div>
    </b-form>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import { forms, resource } from '@/mixins'

export default {
  name: 'resource-form',

  mixins: [forms, resource],

  components: {
    ...mapGetters('resource', ['meta', 'data'])
  },

  methods: {
    ...mapActions('resource', [
      'create',
      'store',
      'show',
      'update'
    ]),

    redirectToIndex () {
      this.$router.push({ name: `${this.$meta.resource}.index` })
    },

    resetForm () {
      this.assignFormData()

      this.done()
    },

    onStore (data) {
      this.store({ data })
    },

    onUpdate (data, id) {
      this.update({ id, data })
    },

    async onDelete (id) {
      await this.deleteItem({ id })

      this.redirectToIndex()
    },

    async init () {
      this.busy()

      if (this.isEditing) {
        await this.show({ id: this.ID })
      } else {
        await this.create()
      }

      this.resetForm()
    }
  }
}
</script>
